> For the complete documentation index, see [llms.txt](https://docs.xchandles.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.xchandles.com/techincal-manual/xchandles/the-initiate-update-action.md).

# The Initiate Update Action

*Note*: The initiate update action code be found [here](https://github.com/Yakuhito/slot-machine/blob/master/rue-puzzles/actions/xchandles/initiate_update.rue) ([Chialisp](https://github.com/Yakuhito/slot-machine/blob/master/puzzles/actions/xchandles/initiate_update.clsp)).

This action handles owner-specific update abilities for every entry. Namely, owners can transfer ownership of their entry or set it to resolve to another singleton. To do so, the owner singleton must create a coin-puzzle message with the contents of `(sha256tree (c handle_hash (c new_owner_launcher_id new_resolved_data)))`.

To prevent certain attacks, an update cannot be completed instantly. Rather, the owner must initiate the update, wait for a 'safe' number of blocks (32 - enough to make blockchain re-orgs extremely unlikely), and then complete the update by having the child of the coin that initiated the update send another message to the distributor.

The singleton keeps track of initiated updates via update slots. An update slot's contents are `(c (c handle_hash (c new_owner_launcher_id new_resolved_data)) (c owner_initiator_coin_id min_execution_height))`.

This puzzle does not create a puzzle announcement, as the owner can be assured the update is initiated only if the message sent to the singleton is consumed. An initiated updated is canceled simply by spending the child of the owner singleton coin that initiated it.

*Written by* [*yakuhito*](https://x.com/yakuhito) *from* [*FireAcademy.io*](https://fireacademy.io/) *on Feb 15th, 2025.*


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.xchandles.com/techincal-manual/xchandles/the-initiate-update-action.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
